<?php

require_once("binary.php");

$fn=$argv[1] or die;
$f=file_get_contents($fn) or die;

$notes = array(
"C"  => 0x2600,
"#C" => 0x2850,
"D"  => 0x2AB0,
"#D" => 0x2D40,
"E"  => 0x2FF0,
"F"  => 0x32C0, "#E" => 0x32C0,
"#F" => 0x35C8,
"G"  => 0x3900,
"#G" => 0x3C60,
"A"  => 0x4000,
"#A" => 0x43D0,
"B"  => 0x47D0, "#B" => 0x47D0,
);

function getnum($f,&$p,$default){
	$v = $default;
	//if ($p<strlen($f)
	//$digit = $f[$p];
	$x = 0;
	while ($p<strlen($f) and ( ($digit = $f[$p]) != "" and $digit >= '0' and $digit <= '9' ) ) {
		$x*=10;
		$x+=(int)$digit;
		$v=$x;
		$p++;
		//if ($p>=strlen($f)) break;
		//$digit = $f[$p];
	}
	return $v;
}
function parse_music($f){
	$p=0;
	$settings = array(
		"=" => 64,
		"O" => 4,
		"V" => 13,
		"length" => -1,
		"T" => 100, // not really
		"Q" => 0,
	);
	while($p<strlen($f)){
		$command=getch($f,$p);
		switch($command) {
			case "$":
			case ")":
			case "=":
			case "@":
			case "H":
			case "I":
			case "J":
			case "K":
			case "L":
			case "M":
			case "N":
			case "O":
			case "P":
			case "Q":
			case "T":
			case "V":
				$n = getnum($f,$p,-1);
				printf("set %s = %d\r\n",$command,$n);
				$settings[$command] = $n;
			break;
			case "#":
				$command .= getch($f,$p);
			case "C":
			case "D":
			case "E":
			case "F":
			case "G":
			case "A":
			case "B":
			case "R":
				$n = getnum($f,$p,$settings["length"]);
				$settings["length"] = $n;
				printf("play note %s length %d\r\n",$command,$n);
				if ($command === "R") {
					$freq = 0;
				} else {
					global $notes;
					$pitch = $notes[$command] >> (6 - $settings["O"]);
					$samplerate = $pitch / 0x1000 * 32000;
					$freq = $samplerate / 72;
				}
				$length = $settings["T"] * $settings["length"] * 2e-4;
				printf("---> freq = %d, length = %f\r\n", $freq,$length);
				global $bas;
				$fill = $settings["Q"];
				if ($fill) {
					$bas .= sprintf("SOUND %d, %f * 18.2\r\n", $freq, $length * $fill/16);
					$bas .= sprintf("SOUND %d, %f * 18.2\r\n", 0, $length * (1-$fill/16));
				} else {
					$bas .= sprintf("SOUND %d, %f * 18.2\r\n", $freq, $length);
				}
			break;
			case "[":
			case "&":
			case "]":
				printf("%s\r\n",$command);
			break;
			case "^":
				$settings["V"] = min($settings["V"]+1, 15);
				printf("inc volume = %d\r\n", $settings["V"]);
			break;
			case "_":
				$settings["V"] = max($settings["V"]-1, 0);
				printf("dec volume = %d\r\n", $settings["V"]);
			break;
			case "+":
				$settings["O"] = $settings["O"]+1 & 7;
				printf("inc octave = %d\r\n", $settings["O"]);
			break;
			case "-":
				$settings["O"] = $settings["O"]-1 & 7;
				printf("dec octave = %d\r\n", $settings["O"]);
			break;
			default:
				printf("Unknown command %s\r\n",$command);
			return;
		}
	}
	print("end\r\n\r\n");
}

$p=0;
$ln=getint2($f,$p);
$dt=getstr($f,$p,$ln);
$f=$dt;

$bas = "";

$p=0;
$instr_addr=getint2($f,$p);
$uk=getint1($f,$p);
for($i=0;$i<8;$i++){
	$q=getint2($f,$p);
	for($j=0;;$j++){
		$tp=getint1($f,$q);
		printf("channel=%d index=%04X type=%02X",$i,$j,$tp);
		//global $bas;
		$bas .= sprintf("PRINT %d, %d\r\n", $i, $j);
		if($tp>=0xFE) break;
		$r=getint2($f,$q);
		$dt=getzstr($f,$r);
		printf(": %s\r\n",$dt);
		parse_music($dt);
	}
	print "\r\n";
	print "\r\n";
}
print "\r\n";
print "Instruments:\r\n";
$p=$instr_addr;
for($i=0;$p<strlen($f);$i++){
	$dt=getstr($f,$p,11);
	printf("%04X: %s\r\n",$i,str2hex($dt));
}

print $bas;
