<?php

$fn=$argv[1];
$start=hexdec($argv[2]);
$off=hexdec($argv[3]);
$labels_fn=$argv[4];

require_once("binary.php");

function label($v,$l){
	//global $labels;
	//if (isset($labels[$v])) return $labels[$v];
	return '$'.h2($v,$l);
}

$opcodes=array(
	0x20=>"CLRP",
	0xCD=>"MOV X,#{n}",
	0xBD=>"MOV SP,X",
	0xE8=>"MOV A,#{n}",
	0x5D=>"MOV X,A",
	0xAF=>"MOV (X)+,A",
	0xC8=>"CMP X,#{n}",
	0xD0=>"BNE {e}",
	0x3F=>"CALL {w}",
	0x8F=>"MOV {b},#{n}", // CSWAP sorrend?
	0xA2=>"CLR5 {b}",
	0xEB=>"MOV Y,{b}",
	0x8D=>"MOV Y,#{n}",
	0xD7=>"MOV [{b}]+Y,A",
	0xFC=>"INC Y",
	0x2D=>"PUSH A",
	0xE4=>"MOVZ A,{b}",
	0x60=>"CLRC",
	0x98=>"ADC {b},#{n}",
	0xAE=>"POP A",
	0x9C=>"DEC A",
	0xC4=>"MOVZ {b},A",
	0x78=>"CMP {b},#{n}",
	0x28=>"AND A,#{n}",
	0x1C=>"ASL A",
	0xFD=>"MOV Y,A",
	0xF6=>"MOV A,{w}+Y",
	0x6F=>"RET",
	0x64=>"CMPZ A,{b}",
	0xBC=>"INC A",
	0x48=>"EOR A,#{n}",
	0xF3=>"BBC7 {a},{e}", // CREL
	0x84=>"ADCZ A,{b}",
	0xFE=>"DBNZ Y,{e}", // R1
	0x08=>"OR A,#{n}",
	0x5F=>"JMP {w}",
	0x68=>"CMP A,#{n}",
	0x90=>"BCC {e}",
	0xA8=>"SBC A,#{n}",
	0xB0=>"BCS {e}",
	0xA4=>"SBCZ A,{b}",
	0xAB=>"INCZ {b}",
	0x24=>"ANDZ A,{b}",
	0x04=>"ORZ A,{b}",
	0xF0=>"BEQ {e}",
	0xB2=>"SET5 {b}",
	0x2F=>"BRA {e}",
	0x6D=>"PUSH Y",
	0xCF=>"MUL YA",
	0xDD=>"MOV A,Y",
	0xEE=>"POP Y",
	0xFA=>"MOV {b},{a}",
	0x69=>"CMP {b},{a}",
	0x80=>"SETC",
	0x3D=>"INC X",
	0x0B=>"ASLZ {b}",
	0xCB=>"MOV {b},Y",
	0xF5=>"MOV A,{w}+X",
	0x4B=>"LSRZ {b}",
	0x6B=>"RORZ {b}",
	0x7A=>"ADDW YA,{b}",
	0x10=>"BPL {e}",
	0x75=>"CMP A,{w}+X",
	0xD5=>"MOV {w}+X,A",
	0xDA=>"MOVW {b},YA",
	0xBA=>"MOVW YA,{b}",
	0x5A=>"CLRW {b}",
	0x9A=>"SUBW YA,{b}",
	0xF4=>"MOVZ A,{b}+X",
	0x9B=>"DEC {b}+X", // +X ?
	0x4D=>"PUSH X",
	0x7D=>"MOV A,X",
	0x88=>"ADC A,#{n}",
	0xCE=>"POP X",
	0x5C=>"LSR A",
	0x95=>"ADC A,{w}+X",
	0x8B=>"DECZ {b}",
	0xF7=>"MOV A,[{b}]+Y",
	0x58=>"EOR {b},#{n}",
	0x3A=>"INCW {b}",
	0xAD=>"CMP Y,#{n}",
	0x9F=>"XCN A",
	0x23=>"BBS1 {a},{e}", // CREL
	0x13=>"BBC0 {a},{e}", // CREL
	0x03=>"BBS0 {a},{e}", // CREL
	0xE5=>"MOV A,{w}",
	0xC5=>"MOV {w},A",
	0x29=>"AND {b},{a}",
	0xB5=>"SBC A,{w}+X",
	0xD4=>"MOVZ {b}+X,A",
	0xDC=>"DEC Y",
	0xE3=>"BBS7 {a},{e}", // CREL
	0x7C=>"ROR A",
	0x44=>"EORZ A,{b}",
	0xFB=>"MOV Y,{b}+X",
	0xDB=>"MOV {b}+X,Y",
	0x1F=>"JMP [{w}+X]",
	0x1A=>"DECW {b}",
	0x1D=>"DEC X",
	0x2E=>"CBNE {a},{e}", // CREL
	0xB8=>"SBC {b},#{n}",
	0x09=>"OR {b},{a}",
	0x38=>"AND {b},#{n}",
	0x30=>"BMI {e}",
	0x15=>"OR A,{w}+X",
	0x43=>"BBS2 {a},{e}", // CREL
	0xF8=>"MOV X,{b}",
	0x9E=>"DIV YA,X",
	0xD8=>"MOV {b},X",
);

$jump=array(
	0xD0=>1,
	0x3F=>1,
	0xF3=>1,
	0x5F=>1,
	0x90=>1,
	0xB0=>1,
	0xF0=>1,
	0x2F=>1,
	0x10=>1,
	0x23=>1,
	0x13=>1,
	0x03=>1,
	0xE3=>1,
	0x2E=>1,
	0x30=>1,
	0x43=>1,
);
$isend=array(
	0x6F=>1,
	0x5F=>1,
	0x2F=>1,
	0x1F=>1,
);

$f=file_get_contents($fn);
include($labels_fn);

$threads=array();
$dec=array();
$next=array();

$p=0x4EF-$off;
for($i=0;$i<0x20;$i++){
	$v=getint2($f,$p);
	if($v) {
		array_push($threads,$v-$off);
	}
}
$p=0xCFD-$off;
for($i=0;$i<0x20;$i++){
	$v=getint2($f,$p);
	if($v) {
		array_push($threads,$v-$off);
	}
}

$p=$start;

$allend=false;
$ix="";
while(!$allend){
	$end=false;
	$sa=$p;
	$op=getint1($f,$p);
	if(isset($opcodes[$op])){
		$line=$opcodes[$op];
		$ref=-1;
		if(strpos($line,"{n}")!==false){
			$v=getint1($f,$p);
			$line=str_replace("{n}",'$'.h2($v,2),$line);
		}
		if(strpos($line,"{a}")!==false){
			$v=getint1($f,$p);
			$line=str_replace("{a}",label($v,2),$line);
			$ref=$v;
		}
		if(strpos($line,"{b}")!==false){
			$v=getint1($f,$p);
			$line=str_replace("{b}",label($v,2),$line);
			$ref=$v;
		}elseif(strpos($line,"{w}")!==false){
			$v=getint2($f,$p);
			$line=str_replace("{w}",label($v,4),$line);
			$ref=$v;
		}elseif(strpos($line,"{e}")!==false){
			$v=getint1($f,$p);
			if($v&0x80) $v-=0x100;
			$v+=$off+$p;
			$line=str_replace("{e}",label($v,4),$line);
			$ref=$v;
		}
		if(isset($jump[$op])) array_push($threads,$v-$off);
		if(isset($isend[$op])) $end=true;
	}else{
		$line="Ismeretlen utasts: ".h2($op,2); $end=true; //$allend=true;
	}
	$hex=str2hex(substr($f,$sa,$p-$sa));
	while(strlen($hex)<12) $hex.=" ";
	if (isset($labels[$ref])) $line .= " ; ".$labels[$ref];
	if($end) $line.="\r\n";
	$dec[$sa]=$hex.$line;
	$next[$sa]=$p;
	if($end){
		$ok=false;
		while(count($threads)){
			$p=array_pop($threads);
			if(!isset($dec[$p])){ $ok=true; break; }
		}
		if(!$ok and !count($threads)){
			$allend=true;
		}
		$end=false;
	}
}
ksort($dec);
reset($dec);
$en=0;
foreach($dec as $k=>$v){
	if($en!=$k) print h2($en+$off,4).": ".urlencode(substr($f,$en,$k-$en))." [".h2($k+$off,4)."]\r\n";
	if($k==$start) print "START\r\n";
	if (isset($labels[$k+$off])) print " ; ".$labels[$k+$off]."\r\n";
	print h2($k+$off,4).": ".$v."\r\n";
	$en=$next[$k];
}

